Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/vgrid.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/vgrid.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/vgrid.f90	(revision 5213)
@@ -6,32 +6,87 @@
 !
 ! DESCRIPTION:
-!> @brief vertical grid manager <br/>
+!> @brief This module manage vertical grid.
 !>
 !> @details
+!>    to set the depth of model levels and the resulting vertical scale
+!> factors:<br/>
+!> @code
+!>    CALL vgrid_zgr_z(dd_gdepw(:), dd_gdept(:), dd_e3w(:), dd_e3t(:), 
+!>                     dd_ppkth, dd_ppkth2, dd_ppacr, dd_ppacr2, 
+!>                     dd_ppdzmin, dd_pphmax, dd_pp_to_be_computed, 
+!>                     dd_ppa0, dd_ppa1, dd_ppa2, dd_ppsur)
+!> @endcode
+!>       - dd_gdepw is array of depth value on W point
+!>       - dd_gdept is array of depth value on T point
+!>       - dd_e3w   is array of vertical mesh size on W point
+!>       - dd_e3t   is array of vertical mesh size on T point
+!>       - dd_ppkth              see NEMO documentation
+!>       - dd_ppkth2             see NEMO documentation
+!>       - dd_ppacr              see NEMO documentation
+!>       - dd_ppdzmin            see NEMO documentation
+!>       - dd_pphmax             see NEMO documentation
+!>       - dd_pp_to_be_computed  see NEMO documentation
+!>       - dd_ppa1               see NEMO documentation
+!>       - dd_ppa2               see NEMO documentation
+!>       - dd_ppa0               see NEMO documentation
+!>       - dd_ppsur              see NEMO documentation
+!>    
 !> 
+!>    to set the depth and vertical scale factor in partial step z-coordinate
+!>  case:<br/>
+!> @code
+!>    CALL vgrid_zgr_zps(id_mbathy(:,:), dd_bathy(:,:), id_jpkmax, dd_gdepw(:), 
+!>                       dd_e3t(:), dd_e3zps_min, dd_e3zps_rat)
+!> @endcode
+!>       - id_mbathy is array of bathymetry level
+!>       - dd_bathy  is array of bathymetry
+!>       - id_jpkmax is the maximum number of level to be used
+!>       - dd_gdepw  is array of vertical mesh size on W point
+!>       - dd_e3t    is array of vertical mesh size on T point
+!>       - dd_e3zps_min    see NEMO documentation
+!>       - dd_e3zps_rat    see NEMO documentation
+!>
+!>    to check the bathymetry in levels:<br/>
+!> @code
+!>    CALL vgrid_zgr_bat_ctl(id_mbathy, id_jpkmax, id_jpk)
+!> @endcode
+!>       - id_mbathy is array of bathymetry level
+!>       - id_jpkmax is the maximum number of level to be used
+!>       - id_jpk    is the number of level
+!>   
+!>    to compute bathy level in T,U,V,F point from  Bathymetry file:<br/>
+!> @code
+!>    tl_level(:)=vgrid_get_level(td_bathy, [cd_namelist,] [td_dom,] [id_nlevel])
+!> @endcode
+!>       - td_bathy is Bathymetry file structure
+!>       - cd_namelist is namelist [optional]
+!>       - td_dom is domain structure [optional]
+!>       - id_nlevel is number of lelvel to be used [optional]
+!>    
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
+!> @date November, 2013 - Initial Version
+!> @date Spetember, 2014
+!> - add header
+!>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
 !----------------------------------------------------------------------
 MODULE vgrid
-   USE netcdf
+   USE netcdf                          ! nf90 library
    USE kind                            ! F90 kind parameter
    USE fct                             ! basic usefull function
    USE global                          ! global parameter
    USE phycst                          ! physical constant
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE file                            ! file manager
    USE var                             ! variable manager
    USE dim                             ! dimension manager
    USE dom                             ! domain manager
+   USE grid                            ! grid manager
    USE iom                             ! I/O manager
    USE mpp                             ! MPP manager
    USE iom_mpp                         ! I/O MPP manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
@@ -43,7 +98,4 @@
    PUBLIC :: vgrid_zgr_bat_ctl
    PUBLIC :: vgrid_get_level
-
-!   PRIVATE :: 
-
 
 CONTAINS
@@ -86,5 +138,4 @@
    !> @param[in] dd_ppsur
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE vgrid_zgr_z( dd_gdepw, dd_gdept, dd_e3w, dd_e3t,          &
    &                       dd_ppkth, dd_ppkth2, dd_ppacr, dd_ppacr2,    &
@@ -218,5 +269,4 @@
 
    END SUBROUTINE vgrid_zgr_z
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine set the depth and vertical scale factor in partial step
@@ -231,21 +281,22 @@
    !>      function the derivative of which gives the reference vertical
    !>      scale factors.
-   !>        From  depth and scale factors reference, we compute there new value
+   !>      From  depth and scale factors reference, we compute there new value
    !>      with partial steps  on 3d arrays ( i, j, k ).
    !>
-   !>              w-level: gdepw_ps(i,j,k)  = fsdep(k)
-   !>                       e3w_ps(i,j,k) = dk(fsdep)(k)     = fse3(i,j,k)
-   !>              t-level: gdept_ps(i,j,k)  = fsdep(k+0.5)
-   !>                       e3t_ps(i,j,k) = dk(fsdep)(k+0.5) = fse3(i,j,k+0.5)
-   !>
-   !>        With the help of the bathymetric file ( bathymetry_depth_ORCA_R2.nc),
+   !>      w-level: 
+   !>          - gdepw_ps(i,j,k)  = fsdep(k)
+   !>          - e3w_ps(i,j,k) = dk(fsdep)(k)     = fse3(i,j,k)
+   !>      t-level: 
+   !>          - gdept_ps(i,j,k)  = fsdep(k+0.5)
+   !>          - e3t_ps(i,j,k) = dk(fsdep)(k+0.5) = fse3(i,j,k+0.5)
+   !>
+   !>      With the help of the bathymetric file ( bathymetry_depth_ORCA_R2.nc),
    !>      we find the mbathy index of the depth at each grid point.
    !>      This leads us to three cases:
-   !>
-   !>              - bathy = 0 => mbathy = 0
-   !>              - 1 < mbathy < jpkm1    
-   !>              - bathy > gdepw(jpk) => mbathy = jpkm1  
-   !>
-   !>        Then, for each case, we find the new depth at t- and w- levels
+   !>          - bathy = 0 => mbathy = 0
+   !>          - 1 < mbathy < jpkm1    
+   !>          - bathy > gdepw(jpk) => mbathy = jpkm1  
+   !>
+   !>      Then, for each case, we find the new depth at t- and w- levels
    !>      and the new vertical scale factors at t-, u-, v-, w-, uw-, vw- 
    !>      and f-points.
@@ -257,6 +308,7 @@
    !>      schemes.
    !>
-   !>         c a u t i o n : gdept, gdepw and e3 are positives
-   !>         - - - - - - -   gdept_ps, gdepw_ps and e3_ps are positives
+   !>  @warning 
+   !>         - gdept, gdepw and e3 are positives
+   !>         - gdept_ps, gdepw_ps and e3_ps are positives
    !
    !> @author A. Bozec, G. Madec
@@ -274,5 +326,4 @@
    !> @param[in] dd_e3zps_rat
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE vgrid_zgr_zps( id_mbathy, dd_bathy, id_jpkmax, &
    &                         dd_gdepw, dd_e3t,               &
@@ -362,5 +413,4 @@
 
    END SUBROUTINE vgrid_zgr_zps
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine check the bathymetry in levels 
@@ -386,7 +436,8 @@
    !> - 03-08 Original code
    !
-   !> @param[in] 
+   !> @param[in] id_mbathy 
+   !> @param[in] id_jpkmax
+   !> @param[in] id_jpk
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE vgrid_zgr_bat_ctl( id_mbathy, id_jpkmax, id_jpk)
       IMPLICIT NONE
@@ -477,38 +528,39 @@
 
    END SUBROUTINE vgrid_zgr_bat_ctl
-   !> @endcode
    !-------------------------------------------------------------------
-   !> @brief This function 
+   !> @brief This function compute bathy level in T,U,V,F point, and return 
+   !> them as array of variable structure
    !
    !> @details
+   !> Bathymetry is read on Bathymetry file, then bathy level is computed 
+   !> on T point, and finally fit to U,V,F point.
+   !>
+   !> you could specify :<br/>
+   !> - namelist where find parameter to set the depth of model levels
+   !> (default use GLORYS 75 levels parameters)
+   !> - domain structure to specify on e area to work on
+   !> - number of level to be used
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] 
+   !> @param[in] td_bathy     Bathymetry file structure 
+   !> @param[in] cd_namelist  namelist 
+   !> @param[in] td_dom       domain structure
+   !> @param[in] id_nlevel    number of lelvel to be used 
+   !> @return array of level on T,U,V,F point (variable structure)
    !-------------------------------------------------------------------
-   !> @code
    FUNCTION vgrid_get_level(td_bathy, cd_namelist, td_dom, id_nlevel)
       IMPLICIT NONE
       ! Argument
-      TYPE(TFILE)     , INTENT(IN) :: td_bathy
-      CHARACTER(LEN=*), INTENT(IN) :: cd_namelist
+      TYPE(TMPP)      , INTENT(IN) :: td_bathy
+      CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: cd_namelist
       TYPE(TDOM)      , INTENT(IN), OPTIONAL :: td_dom
       INTEGER(i4)     , INTENT(IN), OPTIONAL :: id_nlevel
 
       ! function
-      TYPE(TVAR), DIMENSION(ig_npoint) :: vgrid_get_level
+      TYPE(TVAR), DIMENSION(ip_npoint) :: vgrid_get_level
 
       ! local variable
-      TYPE(TFILE) :: tl_bathy
-      TYPE(TMPP)  :: tl_mppbathy
-
-      TYPE(TDOM)  :: tl_dom
-
-      TYPE(TVAR)  :: tl_var
-      TYPE(TVAR) , DIMENSION(ig_npoint)            :: tl_level
-
-      TYPE(TDIM) , DIMENSION(ip_maxdim)            :: tl_dim
-
       REAL(dp)   , DIMENSION(:)      , ALLOCATABLE :: dl_gdepw 
       REAL(dp)   , DIMENSION(:)      , ALLOCATABLE :: dl_gdept 
@@ -519,8 +571,17 @@
       INTEGER(i4)                                  :: il_fileid
       INTEGER(i4)                                  :: il_jpkmax
+      INTEGER(i4), DIMENSION(2,2)                  :: il_xghost
       INTEGER(i4), DIMENSION(:,:)    , ALLOCATABLE :: il_mbathy
       INTEGER(i4), DIMENSION(:,:,:,:), ALLOCATABLE :: il_level
       
       LOGICAL                                      :: ll_exist
+
+      TYPE(TDIM) , DIMENSION(ip_maxdim)            :: tl_dim
+
+      TYPE(TDOM)                                   :: tl_dom
+
+      TYPE(TVAR)                                   :: tl_var
+
+      TYPE(TMPP)                                   :: tl_bathy
 
       ! loop indices
@@ -567,62 +628,60 @@
       !----------------------------------------------------------------
 
-      !1- read namelist
-      INQUIRE(FILE=TRIM(cd_namelist), EXIST=ll_exist)
-      IF( ll_exist )THEN
+      IF( PRESENT(cd_namelist) )THEN
+         !1- read namelist
+         INQUIRE(FILE=TRIM(cd_namelist), EXIST=ll_exist)
+         IF( ll_exist )THEN
  
-         il_fileid=fct_getunit()
-
-         OPEN( il_fileid, FILE=TRIM(cd_namelist), &
-         &                FORM='FORMATTED',       &
-         &                ACCESS='SEQUENTIAL',    &
-         &                STATUS='OLD',           &
-         &                ACTION='READ',          &
-         &                IOSTAT=il_status)
-         CALL fct_err(il_status)
-         IF( il_status /= 0 )THEN
-            CALL logger_fatal("VGRID GET LEVEL: ERROR opening "//TRIM(cd_namelist))
+            il_fileid=fct_getunit()
+
+            OPEN( il_fileid, FILE=TRIM(cd_namelist), &
+            &                FORM='FORMATTED',       &
+            &                ACCESS='SEQUENTIAL',    &
+            &                STATUS='OLD',           &
+            &                ACTION='READ',          &
+            &                IOSTAT=il_status)
+            CALL fct_err(il_status)
+            IF( il_status /= 0 )THEN
+               CALL logger_fatal("VGRID GET LEVEL: ERROR opening "//&
+               &  TRIM(cd_namelist))
+            ENDIF
+
+            READ( il_fileid, NML = namzgr )
+            READ( il_fileid, NML = namzps )
+
+            CLOSE( il_fileid, IOSTAT=il_status )
+            CALL fct_err(il_status)
+            IF( il_status /= 0 )THEN
+               CALL logger_error("VGRID GET LEVELL: ERROR closing "//&
+               &  TRIM(cd_namelist))
+            ENDIF
+
+         ELSE
+
+            CALL logger_fatal("VGRID GET LEVEL: ERROR. can not find "//&
+            &  TRIM(cd_namelist))
+
          ENDIF
-
-         READ( il_fileid, NML = namzgr )
-         READ( il_fileid, NML = namzps )
-
-         CLOSE( il_fileid, IOSTAT=il_status )
-         CALL fct_err(il_status)
-         IF( il_status /= 0 )THEN
-            CALL logger_error("VGRID GET LEVELL: ERROR closing "//TRIM(cd_namelist))
-         ENDIF
-
+      ENDIF
+
+      ! copy structure
+      tl_bathy=mpp_copy(td_bathy)
+
+      ! get domain
+      IF( PRESENT(td_dom) )THEN
+         tl_dom=dom_copy(td_dom)
       ELSE
-
-         CALL logger_fatal("VGRID GET LEVEL: ERROR. can not find "//TRIM(cd_namelist))
-
-      ENDIF
-
-      !2- open files
-      tl_bathy=td_bathy
-      !2-1 get domain
-      IF( PRESENT(td_dom) )THEN
-         tl_dom=td_dom
-      ELSE
-         CALL iom_open(tl_bathy)
-
          CALL logger_debug("VGRID GET LEVEL: get dom from "//&
          &  TRIM(tl_bathy%c_name))
          tl_dom=dom_init(tl_bathy)
-
-         CALL iom_close(tl_bathy)
       ENDIF
 
-      !2-2 open mpp 
-      tl_mppbathy=mpp_init(tl_bathy)
-      CALL file_clean(tl_bathy)
-
-      !2-3 get processor to be used
-      CALL mpp_get_use( tl_mppbathy, tl_dom )
-
-      !2-4 open mpp files
-      CALL iom_mpp_open(tl_mppbathy)
-
-      !3- check namelist
+      ! get ghoste cell
+      il_xghost(:,:)=grid_get_ghost(tl_bathy)
+
+      ! open mpp files
+      CALL iom_dom_open(tl_bathy, tl_dom)
+
+      ! check namelist
       IF( PRESENT(id_nlevel) ) in_nlevel=id_nlevel
       IF( in_nlevel == 0 )THEN
@@ -631,16 +690,22 @@
       ENDIF
 
-      !4- read bathymetry
-      tl_var=iom_mpp_read_var(tl_mppbathy,'bathymetry',td_dom=tl_dom)
-
+      ! read bathymetry
+      tl_var=iom_dom_read_var(tl_bathy,'bathymetry',tl_dom)
+      ! clean
+      CALL dom_clean(tl_dom)
+
+      ! remove ghost cell
+      CALL grid_del_ghost(tl_var, il_xghost(:,:))
+
+      ! force _FillValue (land) to be 0
       WHERE( tl_var%d_value(:,:,1,1) == tl_var%d_fill )
          tl_var%d_value(:,:,1,1)=0
       END WHERE
 
-      !5 clean
-      CALL iom_mpp_close(tl_mppbathy)
-      CALL mpp_clean(tl_mppbathy)
-
-      !5- compute vertical grid
+      ! clean
+      CALL iom_dom_close(tl_bathy)
+      CALL mpp_clean(tl_bathy)
+
+      ! compute vertical grid
       ALLOCATE( dl_gdepw(in_nlevel), dl_gdept(in_nlevel) ) 
       ALLOCATE(   dl_e3w(in_nlevel),   dl_e3t(in_nlevel) ) 
@@ -650,5 +715,5 @@
       &                 dn_ppa0, dn_ppa1, dn_ppa2, dn_ppsur )
 
-      !6- compute bathy level on T point
+      ! compute bathy level on T point
       ALLOCATE( il_mbathy(tl_var%t_dim(1)%i_len, &
       &                   tl_var%t_dim(2)%i_len ) )
@@ -660,8 +725,8 @@
       DEALLOCATE(   dl_e3w,   dl_e3t )
 
-      !7- compute bathy level in T,U,V,F point
+      ! compute bathy level in T,U,V,F point
       ALLOCATE( il_level(tl_var%t_dim(1)%i_len, &
       &                  tl_var%t_dim(2)%i_len, &
-      &                  ig_npoint,1) )
+      &                  ip_npoint,1) )
 
       DO jj=1,tl_var%t_dim(2)%i_len
@@ -686,5 +751,6 @@
       DEALLOCATE( il_mbathy )
 
-      tl_dim(:)=tl_var%t_dim(:)
+      tl_dim(:)=dim_copy(tl_var%t_dim(:))
+      ! clean
       CALL var_clean(tl_var)
 
@@ -692,61 +758,24 @@
       tl_dim(3:4)%l_use=.FALSE.
 
-      tl_level(jp_T)=var_init('tlevel',il_level(:,:,jp_T:jp_T,:),td_dim=tl_dim(:))
-      tl_level(jp_U)=var_init('ulevel',il_level(:,:,jp_U:jp_U,:),td_dim=tl_dim(:))
-      tl_level(jp_V)=var_init('vlevel',il_level(:,:,jp_V:jp_V,:),td_dim=tl_dim(:))
-      tl_level(jp_F)=var_init('flevel',il_level(:,:,jp_F:jp_F,:),td_dim=tl_dim(:))
+      vgrid_get_level(jp_T)=var_init( 'tlevel', il_level(:,:,jp_T:jp_T,:), &
+      &                                td_dim=tl_dim(:) )
+      vgrid_get_level(jp_U)=var_init( 'ulevel', il_level(:,:,jp_U:jp_U,:), &
+      &                                td_dim=tl_dim(:))
+      vgrid_get_level(jp_V)=var_init( 'vlevel', il_level(:,:,jp_V:jp_V,:), &
+      &                                td_dim=tl_dim(:))
+      vgrid_get_level(jp_F)=var_init( 'flevel', il_level(:,:,jp_F:jp_F,:), &
+      &                                td_dim=tl_dim(:))
 
       DEALLOCATE( il_level )
 
-      ! save result
-      vgrid_get_level(:)=tl_level(:)
-
-      DO ji=1,ig_npoint
-         CALL var_clean(tl_level(ji))
-      ENDDO
+      CALL grid_add_ghost( vgrid_get_level(jp_T), il_xghost(:,:) )
+      CALL grid_add_ghost( vgrid_get_level(jp_U), il_xghost(:,:) )
+      CALL grid_add_ghost( vgrid_get_level(jp_V), il_xghost(:,:) )
+      CALL grid_add_ghost( vgrid_get_level(jp_F), il_xghost(:,:) )
+
+      ! clean
+      CALL dim_clean(tl_dim(:))
 
    END FUNCTION vgrid_get_level
-   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief This function 
-!   !
-!   !> @details
-!   !
-!   !> @author J.Paul
-!   !> - Nov, 2013- Initial Version
-!   !
-!   !> @param[in] 
-!   !-------------------------------------------------------------------
-!   !> @code
-!   FUNCTION vgrid_()
-!      IMPLICIT NONE
-!      ! Argument      
-!      ! function
-!      ! local variable
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END FUNCTION vgrid_
-!   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief This subroutine 
-!   !
-!   !> @details
-!   !
-!   !> @author J.Paul
-!   !> - Nov, 2013- Initial Version
-!   !
-!   !> @param[in] 
-!   !-------------------------------------------------------------------
-!   !> @code
-!   SUBROUTINE vgrid_()
-!      IMPLICIT NONE
-!      ! Argument      
-!      ! local variable
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END SUBROUTINE vgrid_
-!   !> @endcode
 END MODULE vgrid
 
